var follow2_xmlHttpInspect;
function follow2_ajax_request_inspect(url, parameters) {
    follow2_xmlHttpInspect = follow2_GetXmlHttpObjectInspect();
    if (follow2_xmlHttpInspect == null) {
        window.alert("Your browser does not support AJAX!");
        return;
    }
    follow2_xmlHttpInspect.onreadystatechange = follow2_ajax_state_chg_inspect;
    follow2_xmlHttpInspect.open("POST", url, true);
    follow2_xmlHttpInspect.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
    follow2_xmlHttpInspect.setRequestHeader("Content-length", parameters.length);
    follow2_xmlHttpInspect.setRequestHeader("Connection", "close");
    follow2_xmlHttpInspect.send(parameters);
}
function follow2_ajax_state_chg_inspect() {
    switch (follow2_xmlHttpInspect.readyState) {
        case 4:
            follow2_inspectorChecker(follow2_xmlHttpInspect.responseText);
            break;
    }
}
function follow2_GetXmlHttpObjectInspect() {
    var follow2_xmlHttpInspect = null;
    try {
        // Firefox, Opera 8.0+, Safari
        follow2_xmlHttpInspect = new XMLHttpRequest();
    }
    catch (ex) {
        // Internet Explorer
        try {
            follow2_xmlHttpInspect = new ActiveXObject("Msxml2.XMLHTTP");
        }
        catch (ex) {
            follow2_xmlHttpInspect = new ActiveXObject("Microsoft.XMLHTTP");
        }
    }
    return follow2_xmlHttpInspect;
}