function follow2_initFeeds() {
    if ((this.follow2_newFeeds = follow2_getFeeds()).length != 0) follow2_captionFeeds();
    else follow2_captionNoFeeds();
}
function follow2_getFeeds()
{
    var i=0;
    var links=new Array();
    for(var index=0;index<_content.document.getElementsByTagName("link").length;index++)
        if(_content.document.getElementsByTagName("link")[index].type.indexOf("rss")!=-1||_content.document.getElementsByTagName("link")[index].type.indexOf("xml")!=-1||_content.document.getElementsByTagName("link")[index].type.indexOf("atom")!=-1)
        {
            links[i]=new Array();
            links[i]["href"]=_content.document.getElementsByTagName("link")[index]["href"];
            links[i]["type"]=_content.document.getElementsByTagName("link")[index]["type"];
            links[i]["title"]=_content.document.getElementsByTagName("link")[index]["title"];
            links[i]["valid"]="not-checked";
            i++;
        }       
    return links;
}
function follow2_isFeeds()
{
    return ((this.follow2_newFeeds = follow2_getFeeds()).length != 0);
}
function follow2_submitFeeds(response)
{
    if(response==null)
    {
        var feedValidaterParameters = "";
        if(!follow2_isFeeds()) return false;
        for(var index=0;index<this.follow2_newFeeds.length;index++)
        {
            feedValidaterParameters += "url" + index + "=" + follow2_URLEncode(this.follow2_newFeeds[index]["href"]);
            if (index < this.follow2_newFeeds.length - 1) feedValidaterParameters += "&";
        }
        follow2_ajax_request_submit(this.follow2_sys_prefs.getCharPref("serv.dir") + this.follow2_sys_prefs.getCharPref("serv.validater"), feedValidaterParameters, false);
        follow2_captionLoading();
    }
    else
    {
        var responseFeeds=response.split('\n');
        for(var index=0;index<responseFeeds.length;index++)
        {
            var feed = responseFeeds[index].split(',');
            feed[0] = feed[0].replace("http://", "");
            feed[0] = feed[0].replace("www.", "");
            if (feed[3] != "0") {
                this.follow2_conn.executeSimpleSQL("insert or replace into feedsdb(url,title,lasttitle,feed_id,favicon) values('" + feed[0] + "','" + feed[1] + "','" + feed[2] + "','" + feed[3] + "','" + feed[4] + "')");
            }
        }
        if(this.follow2_feedsList!=null&&!this.follow2_feedsList.closed)
        {
            this.follow2_feedsList.close();
            follow2_showFeedsList();
        }
    }    
}
function follow2_addUpdatedFeed(url,title,lasttitle,feedId,favicon)
{
    if(this.follow2_suspendedUpdates==null) this.follow2_suspendedUpdates=new Array();
    var updatedFeed=new Array();
    updatedFeed["url"] = url;
    updatedFeed["title"] = title;
    updatedFeed["lasttitle"] = lasttitle;
    updatedFeed["feedId"]=feedId;
    updatedFeed["favicon"]=favicon;
    this.follow2_suspendedUpdates.unshift(updatedFeed);
}
function follow2_openViewer(url)
{
    gBrowser.selectedTab=gBrowser.addTab(url);
}
function follow2_viewFromList(url)
{
    window.blur();
    window.opener.getBrowser().selectedTab=window.opener.getBrowser().addTab(url);
}
function follow2_deleteFeed(url)
{
    if(window.confirm(document.getElementById("follow2-stringbundle").getString("follow2-feed-list-confirm-delete")))
    {
        this.follow2_conn.executeSimpleSQL("delete from feedsdb where url='" + url + "'");
        follow2_notifyClick(null);
    }
}
function follow2_deleteFromList(url)
{
    if(window.confirm(document.getElementById("follow2-stringbundle").getString("follow2-feed-list-confirm-delete")))
    {
        window.arguments[2].executeSimpleSQL("delete from feedsdb where url='" + url + "'");
        follow2_reloadFeedList();
    }
}
function follow2_loadFeedList()
{
    var feedList=document.getElementById("follow2-feeds-list");
    for(var index=0;index<window.arguments[0].length;index++)
    {
        // Create Elements //
        var eHBox=document.createElement("hbox");
        eHBox.setAttribute("align","center");
        if(index==0) eHBox.setAttribute("class","follow2-feed-in-list-selected");
        else eHBox.setAttribute("class","follow2-feed-in-list-not-selected");
        eHBox.setAttribute("onclick","follow2_feedListSelectFeed(this);");
        
        var eImage=document.createElement("image");
        eImage.setAttribute("class","follow2-feed-icon");
        eImage.setAttribute("orient","vertical");
        if(window.arguments[0][index]["favicon"]!="") eImage.setAttribute("src",window.arguments[0][index]["favicon"]);
        else eImage.setAttribute("src","chrome://follow2/skin/imgs/success.png");
        
        var dots=(window.arguments[0][index]["title"].length>window.arguments[1].getIntPref("feeds-list.title.max-length"))?"...":"";
        var eLabel=document.createElement("label");
        eLabel.setAttribute("orient","vertical");
        eLabel.setAttribute("value",window.arguments[0][index]["title"].substr(0,window.arguments[1].getIntPref("feeds-list.title.max-length"))+dots);
        eLabel.setAttribute("tooltiptext",window.arguments[0][index]["title"]);
        
        var eSpacer=document.createElement("spacer");
        eSpacer.setAttribute("flex","2");
        
        var eButtonView=document.createElement("button");
        eButtonView.setAttribute("orient","vertical");
        eButtonView.setAttribute("label",document.getElementById("follow2-stringbundle").getString("follow2-feed-list-button-view"));
        eButtonView.setAttribute("oncommand","follow2_viewFromList('"+window.arguments[1].getCharPref("serv.viewer-prefix") + window.arguments[0][index]["feedId"] + window.arguments[1].getCharPref("serv.viewer-suffix")+"');");
        
        var eButtonDelete=document.createElement("button");
        eButtonDelete.setAttribute("orient","vertical");
        eButtonDelete.setAttribute("label",document.getElementById("follow2-stringbundle").getString("follow2-feed-list-button-delete"));
        eButtonDelete.setAttribute("oncommand","follow2_deleteFromList('"+window.arguments[0][index]["url"]+"');");
        
        // Append Elements //
        feedList.appendChild(eHBox);
        eHBox.appendChild(eImage);
        eHBox.appendChild(eLabel);
        eHBox.appendChild(eSpacer);
        eHBox.appendChild(eButtonView);
        eHBox.appendChild(eButtonDelete);
    }
    if(window.arguments[0].length==0)
    {
        var eHBox=document.createElement("hbox");
        eHBox.setAttribute("align","center");
        eHBox.setAttribute("class","follow2-feed-in-list-no-feeds");

        var eSpacer=document.createElement("spacer");
        eSpacer.setAttribute("flex","2");

        var eLabel=document.createElement("label");
        eLabel.setAttribute("orient","horizontal");
        eLabel.setAttribute("value",document.getElementById("follow2-stringbundle").getString("follow2-feed-list-no-feeds"));

        feedList.appendChild(eHBox);
        eHBox.appendChild(eLabel);
    }
}
function follow2_reloadFeedList()
{
    window.close();
    window.opener.follow2_showFeedsList();
}